#!/usr/bin/env python3
import argparse
import random

from lib import *

parser = argparse.ArgumentParser(description='Generate a test case from a sequence of word lengths.')
parser.add_argument('-w', dest='w', type=int, help='the width of the test case')
parser.add_argument('integers', metavar='N', type=int, nargs='+', help='a word length')

args = parser.parse_args()
random.seed(987)

words = random_from_lengths(args.integers)
print(len(args.integers), args.w)
print('\n'.join(words))
