#!/usr/bin/env python3
import sys
import random

n = int(sys.argv[1])

order = list(range(1,n+1))
if sys.argv[2] == 'increasing':
    order = list(sorted(order))
elif sys.argv[2] == 'decreasing':
    order = list(sorted(order))[::-1]
elif sys.argv[2] == 'shuffled':
    random.seed(int(sys.argv[-1]))
    random.shuffle(order)

print('%d' % n)
print(' '.join(str(i) for i in order))

