#!/usr/bin/env python3
import random
import sys

random.seed(int(sys.argv[-1]))

n = int(sys.argv[1])

def antipodal(a, b):
    return a[0] == -b[0] and (a[1] - b[1]) % 360 == 180

print('%d' % n)

last = (random.randint(-89, 89), random.randint(-180, 179))
first = last
print('%d %d' % last)

for i in range(n-1):
    while True:
        cur = (random.randint(-89, 89), random.randint(-180, 179))
        if i == n-2 and (cur == first or antipodal(cur, first)):
            continue
        if cur == last or antipodal(cur, last):
            continue
        break

    print('%d %d' % cur)
    last = cur

