#!/usr/bin/env python3
import sys

def antipodes(p,q):
    return p[0] == -q[0] and abs(p[1]-q[1]) == 180

n = int(input())
points = [list(map(int, input().split())) for _ in range(n)]

for i in range(n):
    assert points[i] != points[i-1], 'Two consecutive points are equal!'
    assert not antipodes(points[i], points[i-1]), 'Two consecutive points are antipodes!'

sys.exit(42) 
