#include <stdio.h>
#include <stdlib.h>
#define rep(E, F) for (E = 0; E < (F); E++)
#define per(E, F) for (E = (F) - 1; E >= 0; E--)
int get_int()
{
	int r = 0, c = getchar(), s = 1;
	while (c != '-' && c < '0' || c > '9') c = getchar();
	while (c == '-') s *= -1, c = getchar();
	while (c >= '0' && c <= '9') r = r*10 + c - '0', c = getchar();
	return s*r;
}

int dist(int x, int y, int m)
{
	return (x < y) ? y - x : m + y - x;
}

int sgn(int x)
{
	if (x == 0) { printf("yes\n"); exit(0); }
	return x < 0 ? -1 : 1;
}

int main()
{
	int i, n = get_int(), m = 360*2;
	int a[n], b[n], c[m];
	rep(i, m) c[i] = 0;
	rep(i, n) a[i] = 2*get_int(), b[i] = 2*get_int() + 360;
	rep(i, n) if (b[i] != b[(i + 1)%n])
	{
		int x = b[i], y = b[(i + 1)%n], s = sgn(dist(y, x, m) - dist(x, y, m));
		while (x != y) c[x] = 1, x = (m + x + s)%m;
	}
	rep(i, m) if (!c[i]) break;
	if (i == m) printf("yes\n");
	else printf("no %.1f\n", 0.5*(i - 360.0));
	return 0;
}
