#include "validation.h"

// Check the grammar of the input files.
// You should also check properties of the input.
// E.g., check that a graph is connected.

int main(int argc, char** argv) {
	InputValidator v(argc, argv);
	auto a = v.read_integer("a", 1, 1'000'000);
	v.space();
	auto b = v.read_integer("b", 1, 1'000'000);
	v.space();
	auto c = v.read_integer("c", 1, 1'000'000);
	v.space();
	v.read_integer("v", 1, 6 * a * b * c);
	v.newline();
}
