#!/usr/bin/env python3
import itertools

letters = "MDCLXVI"

M, D, C, L, X, V, I = map(int, input().split())

l = [
    ["MMM", "MM", "M", ""],
    ["DCCC", "DCC", "DC", "D", "CCC", "CC", "CM", "C", ""],
    ["LXXX", "LXX", "LX", "L", "XXX", "XX", "XC", "X", ""],
    ["VIII", "VII", "VI", "V", "III", "II", "IX", "I", ""],
]

ans = {}
for [a, b, c, d] in itertools.product(*l):
    s = a + b + c + d
    cnt = 10 ** 18 + 1
    for l in letters:
        if s.count(l) > 0:
            cnt = min(cnt, locals()[l] // s.count(l))
    if cnt == 0 or cnt > 10 ** 18: continue
    ans[s] = cnt
    for l in letters: locals()[l] -= cnt * s.count(l)

print(sum(v for v in ans.values()))
print(len(ans))
[print(k, v) for k, v in ans.items()]
