#include "validation.h"

// Check the grammar of the input files.
// You should also check properties of the input.
// E.g., check that a graph is connected.

int main(int argc, char** argv) {
	InputValidator v(argc, argv);
	int n = v.read_integer("n", 2, 1000);
	v.newline();
    for (int i=0;i<n;i++){
        v.read_integer("phi", -89, 89);
        v.space();
        v.read_integer("lambda", -180, 179);
        v.newline();
    }
	return 0;
}
