#!/usr/bin/env python3
import sys
import re

line = sys.stdin.readline()
assert re.match('^[1-9][0-9]* [1-9][0-9]* [1-9][0-9]*\n$', line, re.MULTILINE)

n, i, k = map(int, line.strip().split())
assert 1 <= n <= 10**6
assert 1 <= i <= n
assert 1 <= k <= 10**6

assert not sys.stdin.read()
sys.exit(42)

