#include <stdio.h>
#include <math.h>
#define rep(E, F) for (E = 0; E < (F); E++)
#define per(E, F) for (E = (F) - 1; E >= 0; E--)
int get_int()
{
	int r = 0, c = getchar(), s = 1;
	while (c != '-' && c < '0' || c > '9') c = getchar();
	while (c == '-') s *= -1, c = getchar();
	while (c >= '0' && c <= '9') r = r*10 + c - '0', c = getchar();
	return s*r;
}

double expt(int x, int m)
{
	if (x < m) return m;
	return (x + 1.0)/2.0;
}

double prob(double x, double n, double k)
{
	return pow(x/n, k) - pow((x - 1.0)/n, k);
}

int main()
{
	int i, n = get_int(), m = get_int(), k = get_int();
	double r = 0.0;
	rep(i, n) r += prob(i + 1, n, k)*expt(i + 1, m);
	printf("%.8f\n", r);
	return 0;
}
